'''
Created on 2014-5-22
@author: Administrator
'''
from django import http
from django.shortcuts import render_to_response
from django.template.context import RequestContext

class RestView(object):
    methods = ('GET', 'HEAD', 'INDEX')

    @classmethod
    def dispatch(cls, request, *args, **kwargs):       
        print kwargs
        exec_method = kwargs.get('method','')
        resource = cls()
        if exec_method.lower() not in (method.lower() for method in resource.methods):
            return http.HttpResponseNotAllowed(resource.methods)
        try:
            method = getattr(resource, exec_method.lower())
        except AttributeError:
            raise Exception("View method `%s` does not exist." % exec_method.lower())
        if not callable(method):
            raise Exception("View method `%s` is not callable." % exec_method.lower())
        return method(request, *args, **kwargs)
    
    def index(self, request, *args, **kwargs):
        return render_to_response('index.html',{},context_instance=RequestContext(request))


    def get(self, request, *args, **kwargs):
        print 'execute get methos'
        print kwargs
        context = {}
        return render_to_response('get.html',context,context_instance=RequestContext(request))

    def head(self, request, *args, **kwargs):
        print 'execute head method'
        response = self.get(request, *args, **kwargs)
        response.content = 'head method testing'
        return response